\section{Introduction}

Large software systems are often component-based, with different
parts being developed by different suppliers. Before software can be
installed, it has to be determined if different components (or packages)
are compatible.

Determining whether two or more packages can be installed together
is a key issue in the quality assurance process of package-based
distributions. Unfortunately, the sheer number of different configurations
to test makes this task particularly challenging, and hundreds of such
incompatibilities go undetected by the normal testing and distribution
process until they are later reported by a user.

Our project develops techniques and tools to recognize potential conflicts
between packages as early as possible in the development process, so
that unexpected problems in large software systems can be minimized in
the future. It will also provide insights into handling large
component-based systems in general, such as internal software
repositories in large companies, or software in automobiles, which is
also component-based.

The target of this project is Debian Linux, because it is a freely
available, widely used, and a representative use case. The French
side of the project includes several experts on Debian Linux.
The knowledge gained by this work will also be applicable to other
platforms.

\section{Goals}

\subsection{Analysis of resource/feature dependencies by run-time monitoring}

In Debian Linux, software packages are managed via package meta-data.
Current meta-data includes dependencies and conflicts, but the reason
for dependencies and conflicts is not formally defined. Such data is
now maintained manually; we think that formally defined, automatically
generated data can more accurately model the dependency of packages
on resources.

We plan to collect data on resource dependencies by monitoring the
behavior of packages at installation and at run-time. Resources
dependencies to be monitored include network ports, files, library
functions, etc.


\subsection{Generation of test scenarios from dependencies}

This step aims at exploring how far automatically generated data on
dependencies can serve as a starting point to generate test cases,
which evaluate whether a package is in conflict with another package.

We plan to use feature-oriented testing, a technology that expresses
dependencies between features (in our case, resources packages provide
or depend on). Mapping resources onto features then allows us to
generate sets of packages that need to be tested. The key challenge
in this phase is to reduce the overall number of test cases to a
manageable and relevant test set.


\subsection{Test execution}

This step executes tests generated by earlier steps, and analyzes the
outcome to diagnose potential problems between packages. System tests
of packages are currently not well defined, but we plan to further
develop existing mechanisms so they can be used to diagnose or analyze
defects.

The main goal in this step is to build a platform for the execution of
both build-time and post-installation tests. Zacchiroli has already
started work in this direction, but the coverage of existing test
suites are still limited. Our tool will support test execution in
virtualized environments to avoid damaging the host system.


To summarize, our goal is to (1) analyze dependencies of packages based
on their behavior, (2) generate test cases from these dependencies, and
(3) provide a framework to execute these tests to provide evidence of
conflicts. Our tool will detect problems between components and also
provide a scenario that shows the problem.
